/**
 * This file was auto-generated by the Titanium Module SDK helper for Android
 * Appcelerator Titanium Mobile
 * Copyright (c) 2009-2010 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 *
 */
package com.navistar.wificonnect;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import org.appcelerator.kroll.KrollFunction;
import org.appcelerator.kroll.KrollModule;
import org.appcelerator.kroll.annotations.Kroll;
import org.appcelerator.titanium.TiApplication;
import org.appcelerator.kroll.common.Log;
import org.appcelerator.kroll.common.TiConfig;

import java.util.Timer;
import java.util.TimerTask;

import android.os.Handler;

import org.json.JSONArray;
import org.json.JSONObject;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
//
import android.net.ConnectivityManager;
import android.net.Network;
import android.net.NetworkCapabilities;
import android.net.NetworkInfo;
import android.net.NetworkRequest;
import android.net.wifi.SupplicantState;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.net.wifi.ScanResult;
import android.os.Build;
import android.os.CountDownTimer;
import android.os.Handler;
import android.os.Message;

@Kroll.module(name="Wificonnect", id="com.navistar.wificonnect")
public class WificonnectModule extends KrollModule
{

	// Standard Debugging variables
	private static final String LCAT = "WificonnectModule";
	private static final boolean DBG = TiConfig.LOGD;

	// You can define constants with @Kroll.constant, for example:
	// @Kroll.constant public static final String EXTERNAL_NAME = value;

	public WificonnectModule()
	{
		super();
	}

	@Kroll.onAppCreate
	public static void onAppCreate(TiApplication app)
	{
		Log.d(LCAT, "inside onAppCreate");
		// put module init code that needs to run when the application is created
	}

	// Methods
	@Kroll.method
	public String example()
	{
		Log.d(LCAT, "example called");
		return "hello world";
	}

	// Properties
	@Kroll.getProperty
	public String getExampleProp()
	{
		Log.d(LCAT, "get example property");
		return "hello world";
	}


	@Kroll.setProperty
	public void setExampleProp(String value) {
		Log.d(LCAT, "set example property: " + value);
	}
	
	TiApplication context = TiApplication.getInstance();
	WifiManager wifiManager = (WifiManager) this.context
			.getSystemService(Context.WIFI_SERVICE);
	ConnectivityManager connectivityManager = (ConnectivityManager) this.context
			.getSystemService("connectivity");
	@SuppressWarnings("deprecation")
	NetworkInfo mWifi = this.connectivityManager.getNetworkInfo(1);
	WifiConfiguration wifiConfig = new WifiConfiguration();
	String initssid;
	StringBuilder sb;
	List<ScanResult> wifiList, scanList;
	int netId;
	int saveNetId;
	List<WifiConfiguration> wifiLis;
	int switchCall = 0;
	List<ScanResult> scannedList;
	

	private class ScanValuePair {
		String SSID;
		String BSSID;
	}


	// Methods
	@Kroll.method
	private boolean checkInternetConnection() {
		if ((this.connectivityManager.getActiveNetworkInfo() != null)
				&& (this.connectivityManager.getActiveNetworkInfo()
						.isAvailable())
				&& (this.connectivityManager.getActiveNetworkInfo()
						.isConnected())) {
			Log.i("checkInternetConnection", "true");
			return true;
		}
		Log.i("checkInternetConnection", "false");
		return false;
	}

	@Kroll.method
	public Object[] getNetworkList() {
		wifiManager.startScan();

		wifiList = new ArrayList<ScanResult>();

		wifiList = wifiManager.getScanResults();

		ArrayList<Object> jsonObjList = new ArrayList<Object>();

		if (wifiList != null && wifiList.size() > 0) {

			for (int i = 0; i < wifiList.size(); i++) {

				HashMap<String, Object> jsonObjectMap = new HashMap<String, Object>();

				try {
					if (wifiList.get(i).SSID.toString() != null
							&& wifiList.get(i).SSID.toString().length() > 0) {
						jsonObjectMap.put("ssid",
								wifiList.get(i).SSID.toString());
					} else {
						jsonObjectMap.put("ssid", "");
					}

					// Set Capabilities
					if (wifiList.get(i).capabilities.toString() != null
							&& wifiList.get(i).capabilities.toString().length() > 0) {
						jsonObjectMap.put("capabilities",
								wifiList.get(i).capabilities.toString());
					} else {
						jsonObjectMap.put("capabilities", "");
					}

					// Set Level
					jsonObjectMap.put("level", wifiList.get(i).level);
				} catch (Exception e) {
					e.printStackTrace();
				} finally {
					jsonObjList.add(jsonObjectMap);
				}

			}
		}

		Object[] objArray = jsonObjList.toArray(new Object[jsonObjList.size()]);

		return objArray;
	}

	private String[] parseJSONArray(JSONArray jsonArray) {
		Log.d(LCAT, "start parseJSONArray");
		ArrayList<String> list = new ArrayList<String>();
		if (jsonArray != null) {
			for (int i = 0; i < jsonArray.length(); i++) {
				try {
					Log.d(LCAT, jsonArray.get(i).toString() + "");

					list.add(jsonArray.get(i).toString() + "");
				} catch (Exception exception) {
					Log.d(LCAT, "invalid object");
					exception.printStackTrace();
				}
			}
		}

		String[] stringArray = list.toArray(new String[list.size()]);

		return stringArray;
	}

	@Kroll.method
	public String currentSSID() {
		WifiInfo wifiInfo = this.wifiManager.getConnectionInfo();
		Log.i("currentSSID--wifiInfo", wifiInfo.toString());
		Log.i("currentSSID--SSID", wifiInfo.getSSID());
		this.initssid = wifiInfo.getSSID().toString();
		return this.initssid;
	}

	@Kroll.method
	public void connectinternet(Boolean flg) {
		this.wifiManager.disconnect();
		this.wifiManager.setWifiEnabled(true);
		this.wifiManager.reassociate();
		connectionCheck(flg);

	}

	@Kroll.method
	public void connectPreviousNet(String netIddvalue) {
		if (android.os.Build.VERSION.SDK_INT > android.os.Build.VERSION_CODES.LOLLIPOP) {
			getNetConnected(netIddvalue);
			connectionCheck(true);
		} else {
			connectinternet(true);
		}

	}

	public void connectionCheck(Boolean flg) {
		HashMap<String, Object> returnval = new HashMap<String, Object>();

		if (flg.booleanValue()) {
			try {

				String SuccessResp = "AddDynamicWifi--connectNetEvent--Success";

				String[] SucessrespArray = { "success", SuccessResp };

				returnval.put("response", SucessrespArray);
				fireEvent("connectNetEvent", returnval);
			} catch (Exception e) {
				String ErrorResp = "AddDynamicWifi--connectNetEvent--Exception Error";

				String[] ErrorrespArray = { "error", ErrorResp };

				returnval.put("response", ErrorrespArray);
				Log.i("Error", "ConnectionError");
				fireEvent("connectNetEvent", returnval);
			}
		}
	}

	public Boolean getNetConnected(String networkSSID) {
		Boolean isNetworkEnabled = false;
		wifiLis = new ArrayList<WifiConfiguration>();
		wifiLis = wifiManager.getConfiguredNetworks();
		if (android.os.Build.VERSION.SDK_INT <= android.os.Build.VERSION_CODES.LOLLIPOP) {
			this.wifiManager.disconnect();
			this.wifiManager.setWifiEnabled(true);
			this.wifiManager.reassociate();
		}
		if (wifiLis != null && wifiLis.size() != 0) {
			for (int i = 0; i < wifiLis.size(); i++) {

				Log.i("",
						"getNetConnected SSID------- "
								+ wifiLis.get(i).SSID.toString() + "NetId"
								+ wifiLis.get(i).networkId);
				// if((wifiList.get(i).BSSID!=null)&&(wifiList.get(i).BSSID!="null")){
				Log.i("",
						"BSSID------- " + networkSSID + "wifi"
								+ wifiLis.get(i).SSID.toString());
				// if(wifiList.get(i).BSSID.toString().equals("any")){
				if ((wifiLis.get(i).SSID.toString()
						.equals(("\"" + networkSSID + "\"")))
						|| (wifiLis.get(i).SSID.toString().equals(networkSSID))) {

					int networkId = wifiLis.get(i).networkId;
					Log.i("", "networkId------- " + networkId
							+ wifiLis.get(i).SSID.toString());
					this.wifiManager.disconnect();
					this.wifiManager.enableNetwork(networkId, true);
					this.wifiManager.setWifiEnabled(true);
					this.wifiManager.reconnect();

					isNetworkEnabled = true;
					// }
					// else{
					// isNetworkEnabled= false;
					// }
					// }
					// else{
					// isNetworkEnabled= false;
					// }
				} else {
					isNetworkEnabled = false;
				}
			}

		} else {
			isNetworkEnabled = false;
		}
		return isNetworkEnabled;
	}

	@Kroll.method
	public void savewifi(String networkSSID, String typ, String networkPass,
			int timeoutVal) {

		HashMap<String, Object> returnval = new HashMap<String, Object>();
		try {
			if (getNetConnected(networkSSID)) {
				String SuccessResp = "AddDynamicWifi--savewifi--Type:" + typ
						+ " Network SSID:" + networkSSID;
				Log.i("", "savewifi--SuccessResp------- " + SuccessResp);
				String[] SucessrespArray = { "success", SuccessResp };

				returnval.put("response", SucessrespArray);
				Log.i("", "timeoutVal------- " + timeoutVal);
				if (timeoutVal == 0) {
					fireEvent("connectDongleEvent", returnval);
				} else {
					fireEvent("connectWiFiEvent", returnval);
				}
			} else {
				this.wifiConfig.SSID = String.format("\"%s\"",
						new Object[] { networkSSID });
				this.wifiConfig.allowedKeyManagement.clear();
				if (typ.equals("NONE")) {
					Log.i("", "savewifi--None------- " + typ);
					this.wifiConfig.allowedKeyManagement
							.set(WifiConfiguration.KeyMgmt.NONE);
				} else {
					Log.i("", "savewifi--preSharedKey------- " + typ
							+ networkPass);
					this.wifiConfig.allowedKeyManagement
							.set(WifiConfiguration.KeyMgmt.WPA_PSK);
					this.wifiConfig.preSharedKey = String.format("\"%s\"",
							new Object[] { networkPass });

				}
				this.netId = this.wifiManager.addNetwork(this.wifiConfig);
				Log.i("savewifi--NetId", String.valueOf(this.netId));
				this.wifiManager.disconnect();
				this.wifiManager.enableNetwork(this.netId, true);
				this.wifiManager.setWifiEnabled(true);
				this.wifiManager.reassociate();

				String SuccessResp = "AddDynamicWifi--savewifi--Type:" + typ
						+ " Network SSID:" + networkSSID;

				String[] SucessrespArray = { "success", SuccessResp };

				returnval.put("response", SucessrespArray);

				if (timeoutVal == 0) {
					fireEvent("connectDongleEvent", returnval);
				} else {
					fireEvent("connectWiFiEvent", returnval);
				}
			}
		} catch (Exception e) {
			Log.i("", "AddDynamicWifi--savewifi--Exception--" + e);
			String ErrorResp = "AddDynamicWifi--savewifi--Exception--" + e;
			this.wifiManager.disconnect();
			this.wifiManager.setWifiEnabled(true);
			this.wifiManager.reconnect();
			String[] ErrorrespArray = { "error", ErrorResp };

			returnval.put("response", ErrorrespArray);
			if (timeoutVal == 0) {
				fireEvent("connectDongleEvent", returnval);
			} else {
				fireEvent("connectWiFiEvent", returnval);
			}
		}

	}

	@Kroll.method
	public void removeNetwork() {

		Log.i("", "Error-------notconnected " + this.netId);
		this.wifiManager.disableNetwork(this.netId);
		this.wifiManager.removeNetwork(this.netId);
		this.wifiManager.saveConfiguration();
		Log.i("", "Check" + checkInternetConnection());

	}

	@Kroll.method
	public void forceCellularConnection(){
		this.wifiManager.disconnect();	
		this.wifiManager.setWifiEnabled(false);
		  if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
		        NetworkRequest.Builder request = new NetworkRequest.Builder();

		        Log.i("forceCellularConnection","request TRANSPORT_CELLULAR");
		        request.addCapability(NetworkCapabilities.TRANSPORT_CELLULAR);

		        connectivityManager.requestNetwork(request.build(), new ConnectivityManager.NetworkCallback() {
		            @Override
		            public void onAvailable(Network network) {
		                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
		                	 Log.i("forceCellularConnection","binding app to cellular network");
		                    connectivityManager.bindProcessToNetwork(network);
		                }
		            }
		        });

		    }
	}
	
	@Kroll.method
	public void removeCellularConnection(){
		  if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
		        NetworkRequest.Builder request = new NetworkRequest.Builder();

		        Log.i("forceCellularConnection","request WIFI enable");
		        request.addCapability(NetworkCapabilities.TRANSPORT_WIFI);

		        connectivityManager.requestNetwork(request.build(), new ConnectivityManager.NetworkCallback() {
		            @Override
		            public void onAvailable(Network network) {
		                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
		                	 Log.i("forceCellularConnection","binding app to cellular network");
		                    connectivityManager.bindProcessToNetwork(network);
		                }
		            }
		        });

		    }
	}
	@Kroll.method
	public void setdisableWifi() {
		this.wifiManager.setWifiEnabled(false);
	}

	@Kroll.method
	public void forgetNetwork(String ssid) {
		List<WifiConfiguration> list = this.wifiManager.getConfiguredNetworks();

		if (list == null) {
			return;
		}

		for (WifiConfiguration configuration : list) {

			String formatedssid = '"' + ssid + '"';

			Log.i("Send formatedssid", " ====" + formatedssid);
			Log.i("Config SSID", " ====" + configuration.SSID);
			Log.i("Config networkId", " ====" + configuration.networkId);

			if (configuration != null
					&& formatedssid.contains(configuration.SSID)) {
				Log.i("MAtched ==", configuration.SSID);
				this.wifiManager.disableNetwork(configuration.networkId);
				this.wifiManager.removeNetwork(configuration.networkId);
				this.wifiManager.saveConfiguration();
				break;
			}

		}
	}
	private int getExistingNetworkId(String SSID) {
	    List<WifiConfiguration> configuredNetworks = wifiManager.getConfiguredNetworks();
	    if (configuredNetworks != null) {
	        for (WifiConfiguration existingConfig : configuredNetworks) {
	            if (SSID.equalsIgnoreCase(existingConfig.SSID)) {
	                return existingConfig.networkId;
	            }
	        }
	    }
	    return -1;
	}
	@Kroll.method
	public void forgetAllNetwork() {
		List<WifiConfiguration> list = this.wifiManager.getConfiguredNetworks();

		if (list == null) {
			return;
		}

		for (WifiConfiguration configuration : list) {

			if (configuration != null) {
				this.wifiManager.disableNetwork(configuration.networkId);
				this.wifiManager.removeNetwork(configuration.networkId);
				this.wifiManager.saveConfiguration();
			}

		}
	}

	// **********************New Impl ********************
	String networkSSID = "";
	String networkPass = "";
	String capabilities = "";
	String url = "";
	int responseCode = -1;
	static String authMsg = "";
	Timer timer;
	TimerTask timerTask;
	// we are going to use a handler to be able to run in our TimerTask
	final Handler handler = new Handler();
	// initializing callbacks to connect to wifi
	private KrollFunction successCallback = null;
	private KrollFunction errorCallback = null;

	// method to invoke success callback
	private void sendSuccessEvent(String successResponse) {
		if (successCallback != null) {
			HashMap event = new HashMap();
			event.put("response", successResponse);

			// Fire an event directly to the specified listener (callback)
			successCallback.call(getKrollObject(), event);
		}
	}

	// method to invoke error callback
	private void sendErrorEvent(String errorResponse) {
		if (errorCallback != null) {
			HashMap event = new HashMap();
			event.put("response", errorResponse);
			// Fire an event directly to the specified listener (callback)
			errorCallback.call(getKrollObject(), event);
		}
	}

	public void registerCallbacks(HashMap args) {
		Object callback;
		if (args.containsKey("success")) {
			callback = args.get("success");
			if (callback instanceof KrollFunction) {
				successCallback = (KrollFunction) callback;
			}
		}

		if (args.containsKey("error")) {
			callback = args.get("error");
			if (callback instanceof KrollFunction) {
				errorCallback = (KrollFunction) callback;
			}
		}

	}

	private void resetWiFi() {
		this.wifiManager.setWifiEnabled(false);
		this.wifiManager.disconnect();
		this.wifiManager.setWifiEnabled(true);

		getScanningResults();
	}

	private void reConfigWiFi() {
		this.wifiManager.setWifiEnabled(false);
		this.wifiManager.disconnect();
		this.wifiManager.setWifiEnabled(true);
	}

	@Kroll.method
	public void connectToOCLDevice(HashMap args) {

		networkSSID = "";
		networkPass = "";
		capabilities = "";
		responseCode = -1;

		if (args == null) {
			sendErrorEvent("error");
			return;
		} else {

			// re configure Wifi
			// reConfigWiFi();

			if (args.containsKey("networkSSID"))
				networkSSID = args.get("networkSSID").toString();

			if (args.containsKey("networkPass"))
				networkPass = args.get("networkPass").toString();

			if (args.containsKey("capabilities"))
				capabilities = args.get("capabilities").toString();

			registerCallbacks(args);

			IntentFilter intentFilter = new IntentFilter();
			intentFilter.addAction(WifiManager.SUPPLICANT_STATE_CHANGED_ACTION);
			context.registerReceiver(broadcastReceiver, intentFilter);
			Log.i("WIFIMODULE", "Paramters ssid password" + networkSSID + networkPass + capabilities);
			new CountDownTimer(16000, 2000) {

				public void onTick(long millisUntilFinished) {
					Log.i(" Timer ====", "START");
					if (responseCode == -1) {
						responseCode = connectToAP(networkSSID, networkPass,
								capabilities);
						Log.i("Timer responseCode ====",
								String.valueOf(responseCode));
					}
				}

				public void onFinish() {
					Log.i("Timer ====", "FINISH");
					Log.i("authMsg ====", authMsg);

					unregisterReceiverNow();

					if (authMsg.equalsIgnoreCase("ERROR_AUTHENTICATING")
							|| authMsg.equalsIgnoreCase("DISCONNECTED")) {
						sendErrorEvent(authMsg);
					} else if (authMsg.equalsIgnoreCase("CONNECTED")) {
						sendSuccessEvent(authMsg);
					} else {
						sendErrorEvent(authMsg);
					}

				}
			}.start();
		}
	}

	// private void checkConnectToSpecificNetwork(String ssid) {
	//
	// NetworkInfo networkInfo = this.connectivityManager
	// .getNetworkInfo(ConnectivityManager.TYPE_WIFI);
	// WifiInfo wifiInfo = this.wifiManager.getConnectionInfo();
	// if (networkInfo != null && networkInfo.isConnected()
	// && wifiInfo.getSSID().replace("\"", "").equals(ssid)) {
	//
	// Log.i("rht", "======Connected : ");
	// sendSuccessEvent("success");
	//
	// } else {
	//
	// Log.i("rht", "======NOT Connected : ");
	// sendErrorEvent("error");
	//
	// }
	// }

	private int connectToAP(String networkSSID, String networkPasskey,
			String securityMode) {

		List<ScanResult> scanResultList = getScanningResults();
		int res =0;
		for (ScanResult result : scanResultList) {

			if (result.SSID.equals(networkSSID)) {

				try 
				{
					WifiConfiguration wifiConfiguration = createAPConfiguration(
							networkSSID, networkPasskey, securityMode);
					this.wifiManager.setWifiEnabled(true);
					if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.LOLLIPOP) {
						wifiConfiguration.SSID = networkSSID;
						           // int pri = 99;
						            //wifiConfiguration.priority = wifiConfiguration.priority + 1;
						        } else {
						        	wifiConfiguration.SSID = "\"" + networkSSID + "\"";
						        	wifiConfiguration.priority = 40;
						        }
					while(!this.wifiManager.pingSupplicant())
					{
					  Thread.sleep(1000);
					}
					res = this.wifiManager.addNetwork(wifiConfiguration);
					Log.i("WIFI_Connect", "# addNetwork returned " + res);
					if (res == -1) {
			            // Get existed network id if it is already added to WiFi network
						this.wifiManager.updateNetwork(wifiConfiguration);
						res = getExistingNetworkId(networkSSID);
			            Log.d("WIFI_Connect", "getExistingNetworkId: " + res);
			        }
					this.wifiManager.disconnect();
					this.wifiManager.enableNetwork(res, true);
					//this.wifiManager.saveConfiguration();
					this.wifiManager.reconnect();
					return res;
				}catch(Exception ex)
				{
					Log.i("", "AddDynamicWifi--savewifi--Exception--" + ex);
					String ErrorResp = "AddDynamicWifi--savewifi--Exception--" + ex;
					this.wifiManager.disconnect();
					this.wifiManager.saveConfiguration();
					this.wifiManager.setWifiEnabled(true);
					this.wifiManager.reconnect();
					return 1;
				}
			}
		}

		return -1;
	}

	
	private final BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {

			final String action = intent.getAction();

			Log.d("WifiReceiver", ">>>>SUPPLICANT_STATE_CHANGED_ACTION<<<<<<");
			SupplicantState supl_state = ((SupplicantState) intent
					.getParcelableExtra(WifiManager.EXTRA_NEW_STATE));
			switch (supl_state) {
			case ASSOCIATED:
				Log.i("SupplicantState", "ASSOCIATED");
				// authMsg = "ASSOCIATED";
				break;
			case ASSOCIATING:
				// authMsg = "ASSOCIATING";
				Log.i("SupplicantState", "ASSOCIATING");
				break;
			case AUTHENTICATING:
				// authMsg = "AUTHENTICATING";
				Log.i("SupplicantState", "Authenticating...");
				break;
			case COMPLETED:
				authMsg = "CONNECTED";
				Log.i("SupplicantState", "Connected");
				break;
			case DISCONNECTED:
				authMsg = "DISCONNECTED";
				Log.i("SupplicantState", "Disconnected");
				break;
			case DORMANT:
				authMsg = "DORMANT";
				Log.i("SupplicantState", "DORMANT");
				break;
			case FOUR_WAY_HANDSHAKE:
				// authMsg = "FOUR_WAY_HANDSHAKE";
				Log.i("SupplicantState", "FOUR_WAY_HANDSHAKE");
				break;
			case GROUP_HANDSHAKE:
				// authMsg = "GROUP_HANDSHAKE";
				Log.i("SupplicantState", "GROUP_HANDSHAKE");
				break;
			case INACTIVE:
				authMsg = "INACTIVE";
				Log.i("SupplicantState", "INACTIVE");
				break;
			case INTERFACE_DISABLED:
				authMsg = "INTERFACE_DISABLED";
				Log.i("SupplicantState", "INTERFACE_DISABLED");
				break;
			case INVALID:
				authMsg = "INVALID";
				Log.i("SupplicantState", "INVALID");
				break;
			case SCANNING:
				// authMsg = "SCANNING";
				Log.i("SupplicantState", "SCANNING");
				break;
			case UNINITIALIZED:
				authMsg = "UNINITIALIZED";
				Log.i("SupplicantState", "UNINITIALIZED");
				break;
			default:
				authMsg = "UNKNOWN";
				Log.i("SupplicantState", "Unknown");
				break;

			}

			// if failed the errorCode will be not -1
			int supl_error = intent.getIntExtra(
					WifiManager.EXTRA_SUPPLICANT_ERROR, -1);
			if (supl_error == WifiManager.ERROR_AUTHENTICATING) {
				authMsg = "ERROR_AUTHENTICATING";
				unregisterReceiverNow();
			} 
		}

	};

	private void unregisterReceiverNow() {
		try {
			if (broadcastReceiver != null) {
				context.unregisterReceiver(broadcastReceiver);
			}
		} catch (IllegalArgumentException e) {
			Log.i("unregisterReceiver", e.getMessage());
		}
	}

	public List<ScanResult> getScanningResults() {

		List<ScanResult> scanResultList = this.wifiManager.getScanResults();

		Log.i("scanResultList", "# scanResultList returned ==="
				+ scanResultList.size());

		return scanResultList;
	}

	private WifiConfiguration createAPConfiguration(String networkSSID,
			String networkPass, String capabilities) {
		this.wifiConfig.allowedKeyManagement.clear();
		WifiConfiguration wifiConfiguration = new WifiConfiguration();
		wifiConfiguration.allowedKeyManagement.clear();
		wifiConfiguration.status = WifiConfiguration.Status.ENABLED;
		//wifiConfiguration.priority = 40;
		
		wifiConfiguration.SSID = String.format("\"%s\"",
				new Object[] { networkSSID });

		Log.i("networkSSID", "=======" + wifiConfiguration.SSID);

		if (capabilities.toUpperCase().contains("WEP")) {
			Log.i("rht", "Configuring WEP");
			wifiConfiguration.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.WPA_PSK);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.RSN);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.WPA);
			wifiConfiguration.allowedAuthAlgorithms
					.set(WifiConfiguration.AuthAlgorithm.OPEN);
			wifiConfiguration.allowedAuthAlgorithms
					.set(WifiConfiguration.AuthAlgorithm.SHARED);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.CCMP);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.TKIP);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.WEP40);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.WEP104);

			/* if (networkPass.matches("^[0-9a-fA-F]+$")) {
				wifiConfiguration.wepKeys[0] = networkPass;
			} else {
				wifiConfiguration.wepKeys[0] = "\"".concat(networkPass).concat(
						"\"");
			}*/
			wifiConfiguration.wepKeys[0] = String.format("\"%s\"",
					new Object[] { networkPass });
			Log.i("networkSSID", "=======" + wifiConfiguration.wepKeys[0]);
			wifiConfiguration.wepTxKeyIndex = 0;

		} else if (capabilities.toUpperCase().contains("WPA")) {
			Log.i("rht", "Configuring WPA");
			wifiConfiguration.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.WPA_PSK);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.WPA);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.WPA);
			wifiConfiguration.allowedAuthAlgorithms
					.set(WifiConfiguration.AuthAlgorithm.OPEN);
			wifiConfiguration.allowedKeyManagement
					.set(WifiConfiguration.KeyMgmt.WPA_PSK);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.CCMP);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.TKIP);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.WEP40);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.WEP104);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.CCMP);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.TKIP);
			wifiConfiguration.preSharedKey = String.format("\"%s\"",
					new Object[] { networkPass });
			Log.i("network password WPA", "=======" + wifiConfiguration.preSharedKey);
			//wifiConfiguration.preSharedKey = "\"" + networkPass + "\"";

		} else if (capabilities.toUpperCase().contains("PSK")) {
			Log.i("rht", "Configuring PSK");
			wifiConfiguration.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.WPA_PSK);
			wifiConfiguration.preSharedKey = String.format("\"%s\"",
					new Object[] { networkPass });
			Log.i("network password PSK", "=======" + wifiConfiguration.preSharedKey);
			wifiConfiguration.hiddenSSID = true;
			wifiConfiguration.status = WifiConfiguration.Status.ENABLED;
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.TKIP);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.CCMP);
			wifiConfiguration.allowedKeyManagement
					.set(WifiConfiguration.KeyMgmt.WPA_PSK);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.TKIP);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.CCMP);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.RSN);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.WPA);

		} else {

			Log.i("rht", "Configuring OPEN network");
			wifiConfiguration.allowedKeyManagement
					.set(WifiConfiguration.KeyMgmt.NONE);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.RSN);
			wifiConfiguration.allowedProtocols
					.set(WifiConfiguration.Protocol.WPA);
			wifiConfiguration.allowedAuthAlgorithms.clear();
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.CCMP);
			wifiConfiguration.allowedPairwiseCiphers
					.set(WifiConfiguration.PairwiseCipher.TKIP);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.WEP40);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.WEP104);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.CCMP);
			wifiConfiguration.allowedGroupCiphers
					.set(WifiConfiguration.GroupCipher.TKIP);
		}

		return wifiConfiguration;

	}


}

